import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class Alien here.
 * 
 * @author Ethan Noble
 */
public class Alien extends Enemy {
    private int i = 0;
    public Alien(int startFrame, int size, int speed, Color color) {
        super(new int[][][] {  
                                               {{0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0},
                                                {1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1},
                                                {1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 1},
                                                {1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1},
                                                {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                                {0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0},
                                                {0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0},
                                                {0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0}},
                                               {{0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0},
                                                {0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0},
                                                {0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0},
                                                {0, 1, 1, 0, 1, 1, 1, 0, 1, 1, 0},
                                                {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                                {1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 1},
                                                {1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1},
                                                {0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 0}},
                                                
                                               {{0, 0, 0, 1, 1, 0, 0, 0},
                                                {0, 0, 1, 1, 1, 1, 0, 0},
                                                {0, 1, 1, 1, 1, 1, 1, 0},
                                                {1, 1, 0, 1, 1, 0, 1, 1},
                                                {1, 1, 1, 1, 1, 1, 1, 1},
                                                {0, 1, 0, 1, 1, 0, 1, 0},
                                                {1, 0, 0, 0, 0, 0, 0, 1},
                                                {0, 1, 0, 0, 0, 0, 1, 0}},
                                               {{0, 0, 0, 1, 1, 0, 0, 0},
                                                {0, 0, 1, 1, 1, 1, 0, 0},
                                                {0, 1, 1, 1, 1, 1, 1, 0},
                                                {1, 1, 0, 1, 1, 0, 1, 1},
                                                {1, 1, 1, 1, 1, 1, 1, 1},
                                                {0, 0, 1, 0, 0, 1, 0, 0},
                                                {0, 1, 0, 1, 1, 0, 1, 0},
                                                {1, 0, 1, 0, 0, 1, 0, 1}},
                                                
                                               {{0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0},
                                                {0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0},
                                                {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                                {1, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 1},
                                                {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                                {0, 0, 1, 1, 1, 0, 0, 1, 1, 1, 0, 0},
                                                {0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0},
                                                {0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0}},
                                               {{0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0},
                                                {0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0},
                                                {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                                {1, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 1},
                                                {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                                {0, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 0},
                                                {0, 0, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0},
                                                {1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1}},
                                            }, startFrame, 40, speed, size, color);
        setEnemyType("Alien");
        initializeImage();
    }
    
    /**
     * Act
     */
    public void act() {
        move();
        animate();
        generateRandomBullet();
        checkTouchingBarriers();
    }
    
    public void move() {
        checkAtEdge();
        if (getAnimationCounter() % getAnimationSpeed() == 0) {
            setLocation(getX() + getSpeedOfActor(), getY());
        }
    }
    
    private void checkTouchingBarriers() {
        if (isTouching(Barrier.class) || getY() > 680) {
            MyWorld world = (MyWorld) getWorld();
            world.gameOver();
        }
    }
    
    private void generateRandomBullet() {
        List<Ship> ship = getWorld().getObjects(Ship.class);
        
        if (ship.size() > 0) {
            /* Random generation */
            if (Greenfoot.getRandomNumber(2500) < 1) {
                getWorld().addObject(new AlienBullet(), getX(), getY());
            }
            
            /* Some basic alien AI */
            for (int i = -4; i < 5; i++) {
                if (getX() == ship.get(0).getX() + i && Greenfoot.getRandomNumber(100) < 1) {
                    getWorld().addObject(new AlienBullet(), getX() + i, getY());
                }
            }
        }
    }
    
    /**
     * Moves down and switches direction of all aliens if one is
     * touching the edge
     */
    private void checkAtEdge() {
        if (getX() >= getWorld().getWidth() - (getImage().getWidth() / 2 + getSpeedOfActor()) ||
            getX() <= getImage().getWidth() / 2 - getSpeedOfActor()) {
                
            List<Alien> aliens = getWorld().getObjects(Alien.class);
            for (Alien alien : aliens) {
                alien.setSpeedOfActor(alien.getSpeedOfActor() + 1);
                alien.setAnimationSpeed(alien.getAnimationSpeed() - 6);
                if (alien.getAnimationSpeed() <= 0) {
                    alien.setAnimationSpeed(1);
                }
                
                alien.setLocation(alien.getX(), alien.getY() + 5);
                alien.setSpeedOfActor(alien.getSpeedOfActor() * -1); //Switch direction
            }
        }
    }
}
