import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class AlienBullet here.
 * 
 * @author Ethan Noble
 */
public class AlienBullet extends Bullet {
    public AlienBullet() {
        super(new int[][][] {{{1, 0},
                              {0, 1},
                              {1, 0},
                              {0, 1},
                              {1, 0}},
                             {{0, 1},
                              {1, 0},
                              {0, 1},
                              {1, 0},
                              {0, 1}}}, 0, 5, 90, 5, 3, Color.RED);
        addToVelocity(getVector());
        initializeImage();
    }
    
    /**
     * An AlienBullet moves downward until it either hits a ship
     * or the bottom of the screen.
     */
    public void act() {
        move();
        animate();
        changeColor();
        if (checkTouchingBarrier()) {} else {
            if (checkAtEdge()) {} else {checkIsTouchingShip();}
        }
    }
    
    private boolean checkTouchingBarrier() {
        if (isTouching(Barrier.class)) {
            MyWorld world = (MyWorld) getWorld();
            Barrier barrier = (Barrier) getOneIntersectingObject(Barrier.class);
            
            world.createHoleInBarrier(barrier);
            world.clearBarrierObjects();
            world.initializeGroupOfBarrierObjects();
            getWorld().removeObject(this);
            return true;
        }
        
        return false;
    }
    
    private void checkIsTouchingShip() {
        if (isTouching(Ship.class)) {
            Ship ship = (Ship) getOneIntersectingObject(Ship.class);
            ship.explode();
            getWorld().removeObject(this);
        }
    }
    
    private void changeColor() {
        if (getCurrentFrame() == 0) {
            setColor(Color.RED);
        }
        else {
            setColor(Color.ORANGE);
        }
        
        initializeImage();
    }
}
