import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Letter here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class EightBitCharacter extends Actor {
    private int size;  //Must be a multiple of 8
    private String type;
    /*
     *                                    {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {0, 0, 0, 0, 0, 0, 0, 0},
                                           {0, 0, 0, 0, 0, 0, 0, 0},
                                           {0, 0, 0, 0, 0, 0, 0, 0},
                                           {0, 0, 0, 0, 0, 0, 0, 0},
                                           {0, 0, 0, 0, 0, 0, 0, 0},
                                           {0, 0, 0, 0, 0, 0, 0, 0},
                                           {0, 0, 0, 0, 0, 0, 0, 0}},
     */
    private int[][][] digit = new int[][][] {
                                          
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {0, 0, 1, 1, 1, 0, 0, 0},
                                           {0, 1, 0, 0, 1, 1, 0, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {0, 1, 1, 0, 0, 1, 0, 0},
                                           {0, 0, 1, 1, 1, 0, 0, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {0, 0, 0, 1, 1, 0, 0, 0},
                                           {0, 0, 1, 1, 1, 0, 0, 0},
                                           {0, 0, 0, 1, 1, 0, 0, 0},
                                           {0, 0, 0, 1, 1, 0, 0, 0},
                                           {0, 0, 0, 1, 1, 0, 0, 0},
                                           {0, 0, 0, 1, 1, 0, 0, 0},
                                           {0, 1, 1, 1, 1, 1, 1, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {0, 1, 1, 1, 1, 1, 0, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {0, 0, 0, 0, 1, 1, 1, 0},
                                           {0, 0, 1, 1, 1, 1, 0, 0},
                                           {0, 1, 1, 1, 1, 0, 0, 0},
                                           {1, 1, 1, 0, 0, 0, 0, 0},
                                           {1, 1, 1, 1, 1, 1, 1, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {0, 1, 1, 1, 1, 1, 1, 0},
                                           {0, 0, 0, 0, 1, 1, 0, 0},
                                           {0, 0, 0, 1, 1, 0, 0, 0},
                                           {0, 0, 1, 1, 1, 1, 0, 0},
                                           {0, 0, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {0, 1, 1, 1, 1, 1, 0, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {0, 0, 0, 1, 1, 1, 0, 0},
                                           {0, 0, 1, 1, 1, 1, 0, 0},
                                           {0, 1, 1, 0, 1, 1, 0, 0},
                                           {1, 1, 0, 0, 1, 1, 0, 0},
                                           {1, 1, 1, 1, 1, 1, 1, 0},
                                           {0, 0, 0, 0, 1, 1, 0, 0},
                                           {0, 0, 0, 0, 1, 1, 0, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 1, 1, 1, 1, 0, 0},
                                           {1, 1, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 1, 1, 1, 1, 0, 0},
                                           {0, 0, 0, 0, 0, 1, 1, 0},
                                           {0, 0, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {0, 1, 1, 1, 1, 1, 0, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {0, 0, 1, 1, 1, 1, 0, 0},
                                           {0, 1, 1, 0, 0, 0, 0, 0},
                                           {1, 1, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 1, 1, 1, 1, 0, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {0, 1, 1, 1, 1, 1, 0, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 1, 1, 1, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {0, 0, 0, 0, 1, 1, 0, 0},
                                           {0, 0, 0, 1, 1, 0, 0, 0},
                                           {0, 0, 1, 1, 0, 0, 0, 0},
                                           {0, 0, 1, 1, 0, 0, 0, 0},
                                           {0, 0, 1, 1, 0, 0, 0, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {0, 1, 1, 1, 1, 0, 0, 0},
                                           {1, 1, 0, 0, 0, 1, 0, 0},
                                           {1, 1, 1, 0, 0, 1, 0, 0},
                                           {0, 1, 1, 1, 1, 0, 0, 0},
                                           {1, 0, 0, 1, 1, 1, 1, 0},
                                           {1, 0, 0, 0, 0, 1, 1, 0},
                                           {0, 1, 1, 1, 1, 1, 0, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {0, 1, 1, 1, 1, 1, 0, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {0, 1, 1, 1, 1, 1, 1, 0},
                                           {0, 0, 0, 0, 0, 1, 1, 0},
                                           {0, 0, 0, 0, 1, 1, 0, 0},
                                           {0, 1, 1, 1, 1, 0, 0, 0}},
                                        };
                                        
    private int[][][] letter = new int[][][] {
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {0, 0, 1, 1, 1, 0, 0, 0},
                                           {0, 1, 1, 0, 1, 1, 0, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 1, 1, 1, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 1, 1, 1, 1, 0, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 1, 1, 1, 1, 0, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 1, 1, 1, 1, 0, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {0, 0, 1, 1, 1, 1, 0, 0},
                                           {0, 1, 1, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 0, 0, 0, 0, 0, 0},
                                           {0, 1, 1, 0, 0, 1, 1, 0},
                                           {0, 0, 1, 1, 1, 1, 0, 0}},
    
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 1, 1, 1, 0, 0, 0},
                                           {1, 1, 0, 0, 1, 1, 0, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 1, 1, 0, 0},
                                           {1, 1, 1, 1, 1, 0, 0, 0}},
    
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 1, 1, 1, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 1, 1, 1, 1, 0, 0},
                                           {1, 1, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 1, 1, 1, 1, 1, 0}}, 
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 1, 1, 1, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 1, 1, 1, 1, 0, 0},
                                           {1, 1, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 0, 0, 0, 0, 0, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {0, 0, 1, 1, 1, 1, 1, 0},
                                           {0, 1, 1, 0, 0, 0, 0, 0},
                                           {1, 1, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 0, 0, 1, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {0, 1, 1, 0, 0, 1, 1, 0},
                                           {0, 0, 1, 1, 1, 1, 1, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 1, 1, 1, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {0, 1, 1, 1, 1, 1, 1, 0},
                                           {0, 0, 0, 1, 1, 0, 0, 0},
                                           {0, 0, 0, 1, 1, 0, 0, 0},
                                           {0, 0, 0, 1, 1, 0, 0, 0},
                                           {0, 0, 0, 1, 1, 0, 0, 0},
                                           {0, 0, 0, 1, 1, 0, 0, 0},
                                           {0, 1, 1, 1, 1, 1, 1, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {0, 0, 0, 0, 0, 1, 1, 0},
                                           {0, 0, 0, 0, 0, 1, 1, 0},
                                           {0, 0, 0, 0, 0, 1, 1, 0},
                                           {0, 0, 0, 0, 0, 1, 1, 0},
                                           {0, 0, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {0, 1, 1, 1, 1, 1, 0, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 1, 1, 0, 0},
                                           {1, 1, 0, 1, 1, 0, 0, 0},
                                           {1, 1, 1, 1, 0, 0, 0, 0},
                                           {1, 1, 1, 1, 1, 0, 0, 0},
                                           {1, 1, 0, 1, 1, 1, 0, 0},
                                           {1, 1, 0, 0, 1, 1, 1, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 1, 1, 1, 1, 1, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 1, 0, 1, 1, 1, 0},
                                           {1, 1, 1, 1, 1, 1, 1, 0},
                                           {1, 1, 1, 1, 1, 1, 1, 0},
                                           {1, 1, 0, 1, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 1, 0, 0, 1, 1, 0},
                                           {1, 1, 1, 1, 0, 1, 1, 0},
                                           {1, 1, 1, 1, 1, 1, 1, 0},
                                           {1, 1, 0, 1, 1, 1, 1, 0},
                                           {1, 1, 0, 0, 1, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {0, 1, 1, 1, 1, 1, 0, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {0, 1, 1, 1, 1, 1, 0, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 1, 1, 1, 1, 0, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 1, 1, 1, 1, 0, 0},
                                           {1, 1, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 0, 0, 0, 0, 0, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {0, 1, 1, 1, 1, 1, 0, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 1, 1, 1, 1, 0},
                                           {1, 1, 0, 0, 1, 1, 0, 0},
                                           {0, 1, 1, 1, 1, 0, 1, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 1, 1, 1, 1, 0, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 1, 1, 1, 0},
                                           {1, 1, 1, 1, 1, 0, 0, 0},
                                           {1, 1, 0, 1, 1, 1, 0, 0},
                                           {1, 1, 0, 0, 1, 1, 1, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {0, 1, 1, 1, 1, 0, 0, 0},
                                           {1, 1, 0, 0, 1, 1, 0, 0},
                                           {1, 1, 0, 0, 0, 0, 0, 0},
                                           {0, 1, 1, 1, 1, 1, 0, 0},
                                           {0, 0, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {0, 1, 1, 1, 1, 1, 0, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {0, 1, 1, 1, 1, 1, 1, 0},
                                           {0, 0, 0, 1, 1, 0, 0, 0},
                                           {0, 0, 0, 1, 1, 0, 0, 0},
                                           {0, 0, 0, 1, 1, 0, 0, 0},
                                           {0, 0, 0, 1, 1, 0, 0, 0},
                                           {0, 0, 0, 1, 1, 0, 0, 0},
                                           {0, 0, 0, 1, 1, 0, 0, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {0, 1, 1, 1, 1, 1, 0, 0}},
                                           
                                          {{0, 0, 0, 0, 0, 0, 0, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {1, 1, 0, 0, 0, 1, 1, 0},
                                           {0, 1, 1, 0, 1, 1, 0, 0},
                                           {0, 0, 1, 1, 1, 0, 0, 0},
                                           {0, 0, 0, 1, 0, 0, 0, 0}},
                                        };  
    public EightBitCharacter(char letter, int size) {
        this.size = size;
        type = "letter";
        getImage().scale(size, size);
        letter -= 97;
        generateCharacter(letter, this.letter);
    }
    
    public EightBitCharacter(int digit, int size) {
        this.size = size;
        type = "digit";
        getImage().scale(size, size);
        generateCharacter(digit, this.digit);
    }
    
    /**
     * Getters
     */
    public String getType() {
        return type;
    }
    
    private void generateCharacter(int indexOfLetter, int[][][] array) {
        getImage().setColor(Color.WHITE);
        for (int y = 0; y < array[0][0].length; y++) {
            for (int x = 0; x < array[0][0].length; x++) {
                if (array[indexOfLetter][y][x] == 1) {
                    int width = getImage().getWidth();
                    int height = getImage().getHeight();
                    getImage().fillRect((x * width) / 8, (y * height) / 8, height / 8, width / 8);
                }
            }
        }
    }
}
