import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Enemy here.
 * 
 * @author Ethan Noble
 */
public abstract class Enemy extends AnimatedActor {
    private int numberOfFragments = 25;
    private String type;
    
    /**
     * Constructor
     */
    public Enemy(int[][][] image, int startFrame, int animationSpeed, int movementSpeed, int size, Color color) {
        super(image, startFrame, animationSpeed, movementSpeed, size, color);
    }
    
    /**
     * Getters
     */
    public int getNumberOfFragments() {
        return numberOfFragments;
    }
    
    public String getEnemyType() {
        return type;
    }
    
    public void setEnemyType(String type) {
        this.type = type;
    }
    
    public void move() {
        setLocation(getX() + getSpeedOfActor(), getY());
    }
    
    public void explode() {
        for (int i = 0; i < numberOfFragments; i++) {
            getWorld().addObject(new Fragment(getColor()), getX(), getY());
        }
        
        Greenfoot.playSound("invaderkilled.wav");
        getWorld().removeObject(this);
    }
}
