import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class AlienFragment here.
 * 
 * @author Ethan Noble
 */
public class Fragment extends SmoothMover {
    private int size = Greenfoot.getRandomNumber(8) + 1;
    private int direction = Greenfoot.getRandomNumber(360);
    private int speed = Greenfoot.getRandomNumber(10) + 5;
    private int turnSpeed = Greenfoot.getRandomNumber(80) + 20;
    private int life = 255;
    private Vector movement = new Vector(direction, speed);
    
    public Fragment(Color alienColor) {
        initializeImage(alienColor);
        addToVelocity(movement);
    }
    
    /**
     * Act
     */
    public void act() {
        move();
        turn(turnSpeed);
        
        getImage().setTransparency(life);
        life -= 1;
        
        if (life <= 0) {
            getWorld().removeObject(this);
        }
        else if (isAtEdge()) {
            getWorld().removeObject(this);
        }
    }
    
    private void initializeImage(Color color) {
        getImage().scale(size, size);
        getImage().setColor(color);
        getImage().fill();
    }
}
