import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Mothership here.
 * 
 * @author Ethan Noble
 */
public class Mothership extends Enemy {
    private GreenfootSound sound = new GreenfootSound("ufo_highpitch.wav");
    
    /**
     * Constructor
     */
    public Mothership(int size, int speed, Color color) {
        super(new int[][][] {{{0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0},
                              {0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0},
                              {0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0},
                              {0, 1, 1, 0, 1, 1, 0, 1, 1, 0, 1, 1, 0, 1, 1, 0},
                              {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                              {0, 0, 1, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 1, 0, 0},
                              {0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0}}}, 0, 20, size, speed, color);
        setEnemyType("Mothership");
        sound.setVolume(75);
        sound.playLoop();
        initializeImage();     
    }
    
    /**
     * Act
     */
    public void act() {
        move();
        checkAtEdge();
    }
    
    private void checkAtEdge() {
        if (getX() > getWorld().getWidth() + 50) {
            sound.stop();
            getWorld().removeObject(this);
        }
    }
    
    public void explode() {
        for (int i = 0; i < getNumberOfFragments(); i++) {
            getWorld().addObject(new Fragment(getColor()), getX(), getY());
        }
        
        sound.stop();
        Greenfoot.playSound("invaderkilled.wav");
        getWorld().removeObject(this);
    }
}
