import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.util.ArrayList;

/**
 * Write a description of class MyWorld here.
 * 
 * @author Ethan Noble
 */
public class MyWorld extends World {
    private static final int START_OF_GRADIENT = 275;
    private int totalPlayerScore = 0;
    private List<Color> alienColors = new ArrayList<Color>();
    private int[][][]barrierArr  = new int[][][] {
                                   {{0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0},
                                    {0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0},
                                    {0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0},
                                    {0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0},
                                    {0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1}},
                                    
                                   {{0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0},
                                    {0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0},
                                    {0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0},
                                    {0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0},
                                    {0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1}},
                                    
                                   {{0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0},
                                    {0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0},
                                    {0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0},
                                    {0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0},
                                    {0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1}},
                                    
                                   {{0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0},
                                    {0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0},
                                    {0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0},
                                    {0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0},
                                    {0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1},
                                    {1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1}},
                                };
    
    public MyWorld() {    
        super(680, 800, 1, false);
        
        alienColors.add(Color.CYAN);
        alienColors.add(Color.RED);
        alienColors.add(Color.GREEN);
        alienColors.add(Color.YELLOW);
        
        /* Create a gradient between black and sky blue */
        getBackground().setColor(Color.BLACK);
        getBackground().fill();

        /*int g = 0;
        int b = 0;
        for (int y = getHeight() - START_OF_GRADIENT; y < getHeight(); y++) {
            for (int x = 0; x < getWidth(); x++) {
                getBackground().setColorAt(x, y, new Color(0, g, b));
            }
            g++; b += 2;
            if (g >= 147) {
                g = 147;
            }
            if (b >= 255) {
                b = 255;
            }
        }*/
        
        /* End of gradient */
        
        generateStars(100);
        
        addObject(new AlienSound(), 0, 0);
        
        updatePlayerScore();
        
        generateLineOfAliens(8, 2, 5, 6, 225);
        generateGroupOfAliens(2, 8, 0, 5, 6, 290);
        generateGroupOfAliens(2, 8, 4, 5, 6, 420);
        
        initializeGroupOfBarrierObjects();
        
        addObject(new Ship(10, Color.RED), getWidth() / 2, getHeight() - 50);
    }
    
    /**
     * Create an alien mothership by random chance.
     * Check if the player has destroyed all the aliens.
     */
    public void act() {
        if (Greenfoot.getRandomNumber(5000) < 1 && getObjects(Mothership.class).size() == 0) {
            addObject(new Mothership(2, 5, Color.ORANGE), -50, 170);
        }
        
        List<Alien> aliens = getObjects(Alien.class);
        if (aliens.size() == 0) {
            gameWon();
        }
    }
    
    private void gameWon() {
        showRetroText("invasion", 32, 95, 150);
        showRetroText("stopped", 32, 32 * 9 + 95, 150);
        Greenfoot.stop();
    }
    
    public void gameOver() {
        showRetroText("game", 64, 90, 150);
        showRetroText("over", 64, 64 * 5 + 90, 150);
        Greenfoot.stop();
    }
    
    public void addToScore(int score) {
        totalPlayerScore += score;
        clearScore();
        updatePlayerScore();
    }
    
    private void clearScore() {
        List<EightBitCharacter> characters = getObjects(EightBitCharacter.class);
        for (EightBitCharacter character : characters) {
            if (character.getType() == "digit") {
                removeObject(character);
            }
        }
    }
    
    private void updatePlayerScore() {
        showRetroText("score", 32, 40, 40);
        showRetroNumber(32, 40, 80);
    }
    
    private void showRetroNumber(int size, int xPos, int yPos) {
        String strTotalPlayerScore = String.valueOf(totalPlayerScore);
        ArrayList<Character> scoreArr = new ArrayList<Character>();
        for (int i = 0; i < strTotalPlayerScore.length(); i++) {
            scoreArr.add(strTotalPlayerScore.charAt(i));
            
        }
        
        for (int i = 0; i < scoreArr.size(); i++) {
            int digit = scoreArr.get(i) - 48;
            
            EightBitCharacter character = new EightBitCharacter(digit, size);
            addObject(character, xPos, yPos);
            xPos += size;
        }
    }
    
    private void showRetroText(String text, int size, int xPos, int yPos) {
        for (int i = 0; i < text.length(); i++) {
            EightBitCharacter character = new EightBitCharacter(text.charAt(i), size);
            addObject(character, xPos, yPos);
            xPos += size;
        }
    }
    
    public void createHoleInBarrier(Barrier barrier) {
        List<Barrier> barriers = barrier.findNeighbors();
        
        removeObject(barrier);
        barrierArr[barrier.getBarrierIndex()][barrier.getYIndexPosition()][barrier.getXIndexPosition()] = 0;
        
        for (Barrier eachBarrier : barriers) {
            removeObject(eachBarrier);
            barrierArr[barrier.getBarrierIndex()][eachBarrier.getYIndexPosition()][eachBarrier.getXIndexPosition()] = 0;
        }
    }
    
    public void clearBarrierObjects() {
        List<Barrier> barriers = getObjects(Barrier.class);
        for (Barrier barrier : barriers) {
            removeObject(barrier);
        }
    }
    
    public void initializeGroupOfBarrierObjects() {
        initializeBarrierObject(0, 70, getHeight() - 200);
        initializeBarrierObject(1, 220, getHeight() - 200);
        initializeBarrierObject(2, 370, getHeight() - 200);
        initializeBarrierObject(3, 520, getHeight() - 200);
    }
    
    private void generateGroupOfAliens(int numberOfLines, int aliensPerLine, int startFrame, int size, int speed, int yPos) {
        for (int i = 0; i < numberOfLines; i++) {
            generateLineOfAliens(aliensPerLine, startFrame, size, speed,yPos + (i * 65));
        }
    }
    
    private void generateLineOfAliens(int numberOfAliens, int startFrame, int size, int speed, int yPos) {
        for (int i = 0; i < numberOfAliens; i++) {
            Color color = alienColors.get(Greenfoot.getRandomNumber(alienColors.size()));
            Alien alien = new Alien(startFrame, size, speed, color);
            addObject(alien, 57 + (i * 80), yPos);
        
        }
    }
    
    private void generateStars(int number) {
        getBackground().setColor(Color.WHITE);
        for (int i = 0; i < number; i++) {
            int xPos = Greenfoot.getRandomNumber(getWidth() - 1);
            int yPos = Greenfoot.getRandomNumber(getHeight()) + 180;
            int size = Greenfoot.getRandomNumber(5) + 5;
            getBackground().fillRect(xPos, yPos, size, size);
        }
    }
    
    private void initializeBarrierObject(int barrierIndex, int xPos, int yPos) {
        int widthArr = barrierArr[barrierIndex][0].length;
        int heightArr = barrierArr[barrierIndex].length;
        
        for (int y = 0; y < heightArr; y++) {
            for (int x = 0; x < widthArr; x++) {
                if (barrierArr[barrierIndex][y][x] == 1) {
                    Barrier barrier = new Barrier(barrierIndex, x, y);
                    addObject(barrier, xPos + (x * barrier.getImage().getWidth()), yPos + (y * barrier.getImage().getHeight()));
                }
            }
        }
    }
}
