import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class PlayerBullet here.
 * 
 * @author Ethan Noble
 */
public class PlayerBullet extends Bullet {
    public PlayerBullet() {
        super(new int[][][] {{{1, 1},
                              {1, 1},
                              {1, 1},
                              {1, 1},
                              {1, 1}}}, 0, 5, 270, 25, 1, Color.WHITE);
        addToVelocity(getVector());
        initializeImage();
    }
    
    /**
     * A PlayerBullet moves upward until it either hits an alien
     * or the top of the screen.
     */
    public void act() {
        move();
        //animate();
        if (checkTouchingBarrier()) {} else {
            if (checkAtEdge()) {} else {checkTouchingEnemy();}
        }
    }
    
    private boolean checkTouchingBarrier() {
        if (isTouching(Barrier.class)) {
            getWorld().removeObject(this);
            return true;
        }
        
        return false;
    }
    
    private void checkTouchingEnemy() {
        if (isTouching(Enemy.class)) {
            MyWorld world = (MyWorld) getWorld();
            
            Enemy enemy = (Enemy) getOneIntersectingObject(Enemy.class);
            enemy.explode();
            
            if (enemy.getEnemyType() == "Mothership") {
                world.addToScore(200);
            }
            else {
                world.addToScore(20);
            }
            
            world.removeObject(this);
        }
    }
}
